Index: src/uk/me/parabola/mkgmap/osmstyle/housenumber/HousenumberGenerator.java
===================================================================
--- src/uk/me/parabola/mkgmap/osmstyle/housenumber/HousenumberGenerator.java	(revision 4258)
+++ src/uk/me/parabola/mkgmap/osmstyle/housenumber/HousenumberGenerator.java	(working copy)
@@ -989,8 +989,9 @@
 			
 			if (road.getStreet() == null){
 				// if a road has a label but getStreet() returns null,
-				// the road probably has a ref. We assume these are not service roads. 
-				if (road.getName() == null){
+				// the road probably has a ref. We assume these are not service roads.
+				// also roads with class > 0 or high road speed values are not service roads
+				if (road.getName() == null && road.getRoadDef().getRoadClass() == 0 && road.getRoadDef().getRoadSpeed() <= 2){
 					unnamedRoads.add(road);
 					List<Coord> nodes = new ArrayList<>();
 					for (Coord co : road.getPoints()){
